# coding:shift_jis

# arcpypbP[W̃C|[g
import arcpy, os, traceback


# ϐ:
inputWorkspace = arcpy.GetParameterAsText(0)    #̓[NXy[X
mesh2FC = arcpy.GetParameterAsText(1)           #2Wn惁bV
outputWorkspace = arcpy.GetParameterAsText(2)   #o̓tH_
overwrite = arcpy.GetParameter(3)               #㏑̋iTrue or Falsej


# 2bVID̃tB[h
mesh2Field = "MESH2_ID"


# o̓t@C̏㏑
if overwrite:
    arcpy.env.overwriteOutput = True
else:
    arcpy.env.overwriteOutput = False


# [NXy[X̐ݒ
arcpy.env.workspace = inputWorkspace

# tB[`NXꗗ̎擾
inputFcList = arcpy.ListFeatureClasses()


# 2bṼR[hꗗ擾
meshRows = arcpy.SearchCursor(mesh2FC)


try:

    # R[ȟJԂ
    for meshRow in meshRows:

        # 2bVID̎擾
        clipMesh2ID = str(meshRow.getValue(mesh2Field))

        arcpy.AddMessage("2bVID: " + clipMesh2ID)

        clipLayer = "clipLayer" + clipMesh2ID
        jouken = "\"" + mesh2Field + "\"=" + clipMesh2ID

        # tB[`C̍쐬 (WIvZVOc[)
        arcpy.MakeFeatureLayer_management(mesh2FC, clipLayer, jouken)


        # o̓tH_pX
        outputFolder = outputWorkspace + os.sep + clipMesh2ID
        outputFolder = outputFolder.encode("shift_jis")

        # o̓tH_̍쐬
        arcpy.AddMessage("o̓tH_̍쐬")

        if os.path.isdir(outputFolder):
            arcpy.AddMessage("tH_͂łɑ݂܂")
        else:
            os.makedirs(outputFolder)


        # NbvtB[`NX̌JԂ
        for inputFC in inputFcList:

            inputFC = inputFC.encode("shift_jis")

            arcpy.AddMessage("Ώ: " + inputFC)

            # o̓f[^̖O
            if inputFC.find(".shp") == -1:
                outputFC = outputFolder + os.sep + inputFC + ".shp"
            else:
                outputFC = outputFolder + os.sep + inputFC

            arcpy.AddMessage("Nbv")

            # Nbv (WIvZVOc[)
            arcpy.Clip_analysis(inputFC, clipLayer, outputFC)

            arcpy.AddMessage("WIg̏C")

            # WIg̏C (WIvZVOc[)
            arcpy.RepairGeometry_management (outputFC, "DELETE_NULL")

        del clipLayer
        del outputFC

except:
    arcpy.AddError(traceback.format_exc())
